//
//  Notification.swift
//  Pachyderm
//
//  Created by Shadowfacts on 9/9/18.
//  Copyright © 2018 Shadowfacts. All rights reserved.
//

import Foundation

public class Notification: Decodable {
    public let id: String
    public let kind: Kind
    public let createdAt: Date
    public let account: Account
    public let status: Status?
    
    public static func dismiss(id notificationID: String) -> Request<Empty> {
        return Request<Empty>(method: .post, path: "/api/v1/notifications/dismiss", body: .parameters([
                "id" => notificationID
            ]))
    }
    
    private enum CodingKeys: String, CodingKey {
        case id
        case kind = "type"
        case createdAt = "created_at"
        case account
        case status
    }
}

extension Notification {
    public enum Kind: String, Decodable, CaseIterable {
        case mention
        case reblog
        case favourite
        case follow
        case followRequest = "follow_request"
    }
}

extension Notification: Identifiable {}
