//
//  Account+Preferences.swift
//  Tusker
//
//  Created by Shadowfacts on 8/28/18.
//  Copyright © 2018 Shadowfacts. All rights reserved.
//

import Foundation
import Pachyderm

extension Account {
    
    var realDisplayName: String {
        if displayName.isEmpty {
            return username
        } else if Preferences.shared.hideCustomEmojiInUsernames {
            return stripCustomEmoji(from: displayName)
        } else {
            return displayName
        }
    }
    
    private static let customEmojiRegex = try! NSRegularExpression(pattern: ":[a-zA-Z0-9_]+:", options: [])
    
    private func stripCustomEmoji(from string: String) -> String {
        let range = NSRange(location: 0, length: string.utf16.count)
        return Account.customEmojiRegex.stringByReplacingMatches(in: string, options: [], range: range, withTemplate: "")
    }
    
}
